<?php

namespace App\Support\Traits;

use App\Services\SysLogService;
use Illuminate\Support\Str;

trait HttpClientHelpers
{

    protected function getPostClient($uri, $paramsBody, $auth = null, $header = null, $json = true)
    {
        $client = app(\GuzzleHttp\Client::class);
        $options = [];

        if($json) {
           $options['headers'] = [
               'Content-Type'=> 'application/json;charset=UTF-8',
           ];

           $options['json'] = $paramsBody;
        }
        else{
            $options['form_params'] = $paramsBody;
        }

        if($auth && is_array($auth)){
            $options['auth'] = $auth;
        }

        $options['headers']['User-Agent'] = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_16_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/79.0.3945.130 Safari/537.36';

        if(!is_null($header)){
            $options['headers'] = array_merge($options['headers'],$header);
        }

        $options['debug'] = env('API_DEBUG');

        $response = $client->request('post',$uri,$options);

        $responseContent = $response->getBody()->getContents();

        app(SysLogService::class)->addApiLogs($responseContent);

        return $responseContent;
    }
}
